<template>
  <div class="login">
    <span @click.stop="openModal()">
      <slot></slot>
    </span>
    <Modal
      class="login"
      :value="loginModal"
      v-if="loginModal"
      @close="closeModal()"
    >
      <div v-if="loginModal" class="login-wrapper">
        <div class="login-title">
          <div>Иҷозатномаи</div>
          <div>
            <span>мутахассис</span>
          </div>
        </div>
        <form @submit.prevent="access ? logIn() : getCode()">
          <div v-if="!access">
            <span>Рақами телефонро ворид кунед</span>
            <Input
              style="margin-top: 10px"
              v-model="phone"
              required
              mask="phone"
            />
          </div>
          <div v-else>
            <span> Рамзи тавассути sms омадаро қайд намоед </span>
            <Input style="margin-top: 10px" v-model="code" type="number" />
          </div>
          <div class="login-buttons">
            <button type="submit" class="curve-btn">
              <div>
                {{ access ? "Дохилшавй" : "Рамзро аз смс ирсол намоед" }}
              </div>
            </button>
          </div>
          <div class="login-footer">
            Шумо кабинети инфиродй надоред ?
            <nuxt-link to="/profile/registration"> Аъзо шудан </nuxt-link>
          </div>
        </form>
      </div>
    </Modal>
  </div>
</template>

<script>
export default {
  data() {
    return {
      loginModal: false,
      phone: "",
      code: "",
      code_store: "",
      access: false,
    };
  },
  methods: {
    openModal() {
      this.loginModal = true;
    },

    closeModal() {
      this.loginModal = false;
      this.code = "";
      this.phone = "";
    },

    async getCode() {
      if (this.code_store) {
        this.code = this.code_store;
        return;
      }
      this.$axios
        .$post("/auth/getcode", { phone: this.phone })
        .then((response) => {
          // this.code = response;
          // this.code_store = response.code;
          console.log(response);
          if (response === "no") {
            this.access = false;
          } else {
            this.access = true;
          }
        })
        .catch((err) => {
          if (err) {
            console.log(err.response);
            if (err.response.data.message == "Invalid phone") {
              alert("Истифодабарандаи бо чунин рақам надорад!");
            }
            if (err.response.data.message == "No access") {
              alert(
                "Истифодабаранда ки ин ракамро дорад, ба барнома дастрасӣ надорад!"
              );
            }
          }
        });
    },

    async logIn() {
      try {
        let data = { phone: this.phone, code: String(this.code) };
        await this.$auth.loginWith("local", { data: data });
        window.location.reload(true);
      } catch (error) {
        console.log(error, " <-errorr");
      }
    },
  },
};
</script>

<style lang="scss">
.login {
  color: #000;
  font-size: 16px;

  &-wrapper {
    // min-height: 450px;
  }
  .modal-content {
    width: 450px;
  }

  &-title {
    margin-top: 20px;
    text-align: center;
    line-height: 1;
    font-size: 28px;

    span {
      font-size: 18px;
    }
  }
  form {
    padding: 60px;
    padding-top: 40px;
    @include less-than(tablet) {
      padding: 30px;
    }
  }

  &-buttons {
    display: flex;
    margin-top: 20px;
    button {
      flex: 2;
      div {
        display: flex;
        justify-content: center;
      }
    }
    button[type="button"] {
      flex: 1;
      background: rgb(221, 221, 221);
      color: #000;
    }
  }
  &-footer {
    margin-top: 20px;

    a {
      width: fit-content;
      display: block;
      border-bottom: 1px dashed #000;
      transition: all ease 0.3s;
      cursor: pointer;
      margin-top: 10px;
      @include less-than(tablet) {
        border-bottom: none;
      }
      &:hover {
        color: #0c63e4;
        border-color: #0c63e4;
      }
    }
  }
}
</style>
